function avg_mtn(p)
% avg_mtn
% by Christian Himpe, 2013 ( http://gramian.de )
% released under BSD 2-Clause License ( http://gramian.de/#license )
%*

if(nargin==0), p = 0; end

format long;

R = 4;

if(p~=1)

S = 8;
T = 1;

X = zeros(8,3);
Y = zeros(8,3,S);

l = tic;
for I=R:S

        I

	for J=1:T
		Y(:,:,I) = Y(:,:,I) + mtn(I);
	end

        Y(:,:,I) = Y(:,:,I)./T;
        Z = Y(:,:,I)
end
toc(l)
save('mtn.mat','Y');
end

if(p~=0)
load('mtn.mat');
S = size(Y,3);
x = (R:S).^2;
y = permute(Y,[3 1 2]);

% Network
figure;

rand('seed',1009);
A = sprand(16,16,0.2);
gplot(A,[cos(pi/8:pi/8:2*pi)',sin(pi/8:pi/8:2*pi)'],'*-k');
axis off;


% Combined Reduction (Inverse)
figure;

subplot(1,3,1); semilogy(x,y(R:S,5,2),'k','LineWidth',2); hold on; semilogy(x,y(R:S,6,1),'g','LineWidth',2); semilogy(x,y(R:S,7,1),'r','LineWidth',2); semilogy(x,y(R:S,8,1),'b','LineWidth',2); hold off; 
xlim([x(1) x(end)]); ylim([1 10000]); legend('Full Order','W_S + W_O','W_C + W_I','W_J','location','NorthWest'); 
title('Offline Time','FontSize',12,'fontWeight','bold'); ylabel('Time (s)','FontSize',12,'fontWeight','bold'); xlabel('States','FontSize',12,'fontWeight','bold'); set(gca,'FontSize',12,'fontWeight','bold');

subplot(1,3,2); semilogy(x,y(R:S,6,2),'g','LineWidth',2); hold on; semilogy(x,y(R:S,7,2),'r','LineWidth',2); semilogy(x,y(R:S,8,2),'b','LineWidth',2); hold off; 
xlim([x(1) x(end)]); ylim([1 10000]); legend('W_S + W_O','W_C + W_I','W_J','location','NorthWest'); 
title('Online Time','FontSize',12,'fontWeight','bold'); ylabel('Time (s)','FontSize',12,'fontWeight','bold'); xlabel('States','FontSize',12,'fontWeight','bold'); set(gca,'FontSize',12,'fontWeight','bold');

subplot(1,3,3); semilogy(x,y(R:S,5,3),'k','LineWidth',2); hold on; semilogy(x,y(R:S,6,3),'g','LineWidth',2); semilogy(x,y(R:S,7,3),'r','LineWidth',2); semilogy(x,y(R:S,8,3),'b','LineWidth',2); hold off; 
xlim([x(1) x(end)]); ylim([0.0001 0.1]); legend('Full Order','W_S + W_O','W_C + W_I','W_J','location','NorthEast'); 
title('Relative Output Error','FontSize',12,'fontWeight','bold'); ylabel('Error','FontSize',12,'fontWeight','bold'); xlabel('States','FontSize',12,'fontWeight','bold'); set(gca,'FontSize',12,'fontWeight','bold');

% Effectivity
figure;

semilogy( (y(R:S,6,1)+y(R:S,6,2))./y(R:S,5,2) , y(R:S,6,3)./y(R:S,5,3),'g','LineWidth',2 ); hold on; 
semilogy( (y(R:S,7,1)+y(R:S,7,2))./y(R:S,5,2) , y(R:S,7,3)./y(R:S,5,3),'r','LineWidth',2 ); 
semilogy( (y(R:S,8,1)+y(R:S,8,2))./y(R:S,5,2) , y(R:S,8,3)./y(R:S,5,3),'b','LineWidth',2 ); hold off; 
xlim([0 1]); ylim([0.01 100]); legend('W_S + W_O','W_C + W_I','W_J','location','NorthEast')
title('Effectivity','FontSize',12,'fontWeight','bold'); ylabel('Normalized Error','FontSize',12,'fontWeight','bold'); xlabel('Normalized Total Time','FontSize',12,'fontWeight','bold'); set(gca,'FontSize',12,'fontWeight','bold');

end
